Subject: bug#55622: closed (Re: bug#55622: Bug in sort with keys and reverse, and version-sort and reverse)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 25 May 2022 08:54:02 +0000

Your bug report

#55622: Bug in sort with keys and reverse, and version-sort and reverse

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
55622: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=55622
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#55622: Bug in sort with keys and reverse, and version-sort and reverse
From: Pádraig Brady <[email-masked]>
To: Larry Ploetz <[email-masked]>, [email-masked]
Date: Wed, 25 May 2022 09:53:08 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

On 25/05/2022 03:00, Larry Ploetz wrote:
> I think I've found a bug in sort (git branch master). The --reverse flag
> seems to be ignored when --keys are supplied.
> 
>      larryp-MBP:bin larry$ ./sort --version
>      sort (GNU coreutils) 9.1.17-a351f
>      Copyright (C) 2022 Free Software Foundation, Inc.
>      License GPLv3+: GNU GPL version 3 or later<https://gnu.org/licenses/gpl.html>.
>      This is free software: you are free to change and redistribute it.
>      There is NO WARRANTY, to the extent permitted by law.
> 
>      Written by Mike Haertel and Paul Eggert.
>      larryp-MBP:bin larry$ ./sort -r <<< $'a\nb'
>      b
>      a
>      larryp-MBP:bin larry$ ./sort -rk1,1 <<< $'a\nb'
>      a
>      b

Thanks for the report.
I pushed the following to address this
https://git.sv.gnu.org/gitweb/?p=coreutils.git;a=commitdiff;h=4e0167ea1

The existing tests are sufficient to catch this.

thanks!
Pádraig

Subject: Bug in sort with keys and reverse, and version-sort and reverse
From: Larry Ploetz <[email-masked]>
To: [email-masked]
Date: Tue, 24 May 2022 19:00:04 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

I think I've found a bug in sort (git branch master). The --reverse flag 
seems to be ignored when --keys are supplied.

    larryp-MBP:bin larry$ ./sort --version
    sort (GNU coreutils) 9.1.17-a351f
    Copyright (C) 2022 Free Software Foundation, Inc.
    License GPLv3+: GNU GPL version 3 or later<https://gnu.org/licenses/gpl.html>.
    This is free software: you are free to change and redistribute it.
    There is NO WARRANTY, to the extent permitted by law.

    Written by Mike Haertel and Paul Eggert.
    larryp-MBP:bin larry$ ./sort -r <<< $'a\nb'
    b
    a
    larryp-MBP:bin larry$ ./sort -rk1,1 <<< $'a\nb'
    a
    b

This may be related to a bug reported in February where --version-sort 
sorted incorrectly.

    larryp-MBP:bin larry$ ./sort -Vr <<< $'1\n2'
    1
    2
    larryp-MBP:bin larry$ ./sort -V <<< $'1\n2'
    1
    2

Current version:

    larryp-MBP:bin larry$ sort --version
    sort (GNU coreutils) 9.1
    Copyright (C) 2022 Free Software Foundation, Inc.
    License GPLv3+: GNU GPL version 3 or later<https://gnu.org/licenses/gpl.html>.
    This is free software: you are free to change and redistribute it.
    There is NO WARRANTY, to the extent permitted by law.

    Written by Mike Haertel and Paul Eggert.
    larryp-MBP:bin larry$ sort -rk1,1 <<< $'a\nb'
    b
    a

Thanks,
· Larry